require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_COMPLEX_H)) {
    eval 'sub _COMPLEX_H () {1;}' unless defined(&_COMPLEX_H);
    eval 'sub __GLIBC_INTERNAL_STARTING_HEADER_IMPLEMENTATION () {1;}' unless defined(&__GLIBC_INTERNAL_STARTING_HEADER_IMPLEMENTATION);
    require 'bits/libc-header-start.ph';
    require 'bits/mathdef.ph';
    require 'bits/floatn.ph';
    if( &__GNUC_PREREQ (2, 7)  && ! &__GNUC_PREREQ (2, 97)) {
	eval 'sub _Complex () { &__complex__;}' unless defined(&_Complex);
    }
    eval 'sub complex () { &_Complex;}' unless defined(&complex);
    eval 'sub _Complex_I () {( &__extension__ 1.0 &iF);}' unless defined(&_Complex_I);
    undef(&I) if defined(&I);
    eval 'sub I () { &_Complex_I;}' unless defined(&I);
    if(defined (&__USE_ISOC11)  &&  &__GNUC_PREREQ (4, 7)) {
	eval 'sub CMPLX {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex ( , ($y)));
	}' unless defined(&CMPLX);
	eval 'sub CMPLXF {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex ( , ($y)));
	}' unless defined(&CMPLXF);
	eval 'sub CMPLXL {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex ( , ($y)));
	}' unless defined(&CMPLXL);
    }
    if((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub CMPLXF128 {
	    my($x, $y) = @_;
    	    eval q( &__builtin_complex (( &_Float128) ($x), ( &_Float128) ($y)));
	}' unless defined(&CMPLXF128);
    }
    eval 'sub __MATHCALL {
        my($function, $args) = @_;
	    eval q( &__MATHDECL ( &_Mdouble_complex_,$function, $args));
    }' unless defined(&__MATHCALL);
    eval 'sub __MATHDECL {
        my($type, $function, $args) = @_;
	    eval q( &__MATHDECL_1($type, $function, $args);  &__MATHDECL_1($type,  &__CONCAT( &__,$function), $args));
    }' unless defined(&__MATHDECL);
    eval 'sub __MATHDECL_1 {
        my($type, $function, $args) = @_;
	    eval q( &extern $type  &__MATH_PRECNAME($function) $args  &__THROW);
    }' unless defined(&__MATHDECL_1);
    eval 'sub _Mdouble_ () {\'double\';}' unless defined(&_Mdouble_);
    eval 'sub __MATH_PRECNAME {
        my($name) = @_;
	    eval q($name);
    }' unless defined(&__MATH_PRECNAME);
    require 'bits/cmathcalls.ph';
    undef(&_Mdouble_) if defined(&_Mdouble_);
    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    unless(defined(&_Mfloat_)) {
	eval 'sub _Mfloat_ () {\'float\';}' unless defined(&_Mfloat_);
    }
    eval 'sub _Mdouble_ () { &_Mfloat_;}' unless defined(&_Mdouble_);
    eval 'sub __MATH_PRECNAME {
        my($name) = @_;
	    eval q($name &f);
    }' unless defined(&__MATH_PRECNAME);
    require 'bits/cmathcalls.ph';
    undef(&_Mdouble_) if defined(&_Mdouble_);
    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    if(((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef) || ((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  && !defined (&_LIBC)))  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	unless(defined(&_Mfloat128_)) {
	    eval 'sub _Mfloat128_ () { &_Float128;}' unless defined(&_Mfloat128_);
	}
	if(defined(&__CFLOAT128)) {
	    undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
	    eval 'sub _Mdouble_complex_ () { &__CFLOAT128;}' unless defined(&_Mdouble_complex_);
	}
	eval 'sub _Mdouble_ () { &_Mfloat128_;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &f128);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&_Mdouble_complex_) if defined(&_Mdouble_complex_);
    }
    if(!(defined (&__NO_LONG_DOUBLE_MATH)  && defined (&_LIBC)) || defined (&__LDBL_COMPAT)) {
	if(defined(&__LDBL_COMPAT)) {
	    undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
	    eval 'sub __MATHDECL_1 {
	        my($type, $function, $args) = @_;
    		eval q( &extern $type  &__REDIRECT_NTH( &__MATH_PRECNAME($function), $args, $function));
	    }' unless defined(&__MATHDECL_1);
	}
	unless(defined(&_Mlong_double_)) {
	    eval 'sub _Mlong_double_ () {\'long double\';}' unless defined(&_Mlong_double_);
	}
	eval 'sub _Mdouble_ () {\'_Mlong_double_\';}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name) = @_;
    	    eval q($name &l);
	}' unless defined(&__MATH_PRECNAME);
	require 'bits/cmathcalls.ph';
    }
    undef(&_Mdouble_) if defined(&_Mdouble_);
    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
    undef(&__MATHDECL) if defined(&__MATHDECL);
    undef(&__MATHCALL) if defined(&__MATHCALL);
}
1;
