require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_INPUT_H)) {
    eval 'sub _INPUT_H () {1;}' unless defined(&_INPUT_H);
    require 'sys/time.ph';
    require 'sys/ioctl.ph';
    require 'sys/types.ph';
    require 'linux/types.ph';
    require 'linux/input-event-codes.ph';
    eval 'sub EV_VERSION () {0x10001;}' unless defined(&EV_VERSION);
    eval 'sub INPUT_KEYMAP_BY_INDEX () {(1<< 0);}' unless defined(&INPUT_KEYMAP_BY_INDEX);
    eval 'sub EVIOCGVERSION () { &_IOR(ord(\'E\'), 0x1, \'int\');}' unless defined(&EVIOCGVERSION);
    eval 'sub EVIOCGID () { &_IOR(ord(\'E\'), 0x2, \'struct input_id\');}' unless defined(&EVIOCGID);
    eval 'sub EVIOCGREP () { &_IOR(ord(\'E\'), 0x3, \'unsigned int\'[2]);}' unless defined(&EVIOCGREP);
    eval 'sub EVIOCSREP () { &_IOW(ord(\'E\'), 0x3, \'unsigned int\'[2]);}' unless defined(&EVIOCSREP);
    eval 'sub EVIOCGKEYCODE () { &_IOR(ord(\'E\'), 0x4, \'unsigned int\'[2]);}' unless defined(&EVIOCGKEYCODE);
    eval 'sub EVIOCGKEYCODE_V2 () { &_IOR(ord(\'E\'), 0x4, \'struct input_keymap_entry\');}' unless defined(&EVIOCGKEYCODE_V2);
    eval 'sub EVIOCSKEYCODE () { &_IOW(ord(\'E\'), 0x4, \'unsigned int\'[2]);}' unless defined(&EVIOCSKEYCODE);
    eval 'sub EVIOCSKEYCODE_V2 () { &_IOW(ord(\'E\'), 0x4, \'struct input_keymap_entry\');}' unless defined(&EVIOCSKEYCODE_V2);
    eval 'sub EVIOCGNAME {
        my($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0x6, $len));
    }' unless defined(&EVIOCGNAME);
    eval 'sub EVIOCGPHYS {
        my($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0x7, $len));
    }' unless defined(&EVIOCGPHYS);
    eval 'sub EVIOCGUNIQ {
        my($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0x8, $len));
    }' unless defined(&EVIOCGUNIQ);
    eval 'sub EVIOCGPROP {
        my($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0x9, $len));
    }' unless defined(&EVIOCGPROP);
    eval 'sub EVIOCGMTSLOTS {
        my($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0xa, $len));
    }' unless defined(&EVIOCGMTSLOTS);
    eval 'sub EVIOCGKEY {
        my($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0x18, $len));
    }' unless defined(&EVIOCGKEY);
    eval 'sub EVIOCGLED {
        my($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0x19, $len));
    }' unless defined(&EVIOCGLED);
    eval 'sub EVIOCGSND {
        my($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0x1a, $len));
    }' unless defined(&EVIOCGSND);
    eval 'sub EVIOCGSW {
        my($len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0x1b, $len));
    }' unless defined(&EVIOCGSW);
    eval 'sub EVIOCGBIT {
        my($ev,$len) = @_;
	    eval q( &_IOC( &_IOC_READ, ord(\'E\'), 0x20 + ($ev), $len));
    }' unless defined(&EVIOCGBIT);
    eval 'sub EVIOCGABS {
        my($abs) = @_;
	    eval q( &_IOR(ord(\'E\'), 0x40 + ($abs), \'struct input_absinfo\'));
    }' unless defined(&EVIOCGABS);
    eval 'sub EVIOCSABS {
        my($abs) = @_;
	    eval q( &_IOW(ord(\'E\'), 0xc0 + ($abs), \'struct input_absinfo\'));
    }' unless defined(&EVIOCSABS);
    eval 'sub EVIOCSFF () { &_IOW(ord(\'E\'), 0x80, \'struct ff_effect\');}' unless defined(&EVIOCSFF);
    eval 'sub EVIOCRMFF () { &_IOW(ord(\'E\'), 0x81, \'int\');}' unless defined(&EVIOCRMFF);
    eval 'sub EVIOCGEFFECTS () { &_IOR(ord(\'E\'), 0x84, \'int\');}' unless defined(&EVIOCGEFFECTS);
    eval 'sub EVIOCGRAB () { &_IOW(ord(\'E\'), 0x90, \'int\');}' unless defined(&EVIOCGRAB);
    eval 'sub EVIOCREVOKE () { &_IOW(ord(\'E\'), 0x91, \'int\');}' unless defined(&EVIOCREVOKE);
    eval 'sub EVIOCGMASK () { &_IOR(ord(\'E\'), 0x92, \'struct input_mask\');}' unless defined(&EVIOCGMASK);
    eval 'sub EVIOCSMASK () { &_IOW(ord(\'E\'), 0x93, \'struct input_mask\');}' unless defined(&EVIOCSMASK);
    eval 'sub EVIOCSCLOCKID () { &_IOW(ord(\'E\'), 0xa0, \'int\');}' unless defined(&EVIOCSCLOCKID);
    eval 'sub ID_BUS () {0;}' unless defined(&ID_BUS);
    eval 'sub ID_VENDOR () {1;}' unless defined(&ID_VENDOR);
    eval 'sub ID_PRODUCT () {2;}' unless defined(&ID_PRODUCT);
    eval 'sub ID_VERSION () {3;}' unless defined(&ID_VERSION);
    eval 'sub BUS_PCI () {0x1;}' unless defined(&BUS_PCI);
    eval 'sub BUS_ISAPNP () {0x2;}' unless defined(&BUS_ISAPNP);
    eval 'sub BUS_USB () {0x3;}' unless defined(&BUS_USB);
    eval 'sub BUS_HIL () {0x4;}' unless defined(&BUS_HIL);
    eval 'sub BUS_BLUETOOTH () {0x5;}' unless defined(&BUS_BLUETOOTH);
    eval 'sub BUS_VIRTUAL () {0x6;}' unless defined(&BUS_VIRTUAL);
    eval 'sub BUS_ISA () {0x10;}' unless defined(&BUS_ISA);
    eval 'sub BUS_I8042 () {0x11;}' unless defined(&BUS_I8042);
    eval 'sub BUS_XTKBD () {0x12;}' unless defined(&BUS_XTKBD);
    eval 'sub BUS_RS232 () {0x13;}' unless defined(&BUS_RS232);
    eval 'sub BUS_GAMEPORT () {0x14;}' unless defined(&BUS_GAMEPORT);
    eval 'sub BUS_PARPORT () {0x15;}' unless defined(&BUS_PARPORT);
    eval 'sub BUS_AMIGA () {0x16;}' unless defined(&BUS_AMIGA);
    eval 'sub BUS_ADB () {0x17;}' unless defined(&BUS_ADB);
    eval 'sub BUS_I2C () {0x18;}' unless defined(&BUS_I2C);
    eval 'sub BUS_HOST () {0x19;}' unless defined(&BUS_HOST);
    eval 'sub BUS_GSC () {0x1a;}' unless defined(&BUS_GSC);
    eval 'sub BUS_ATARI () {0x1b;}' unless defined(&BUS_ATARI);
    eval 'sub BUS_SPI () {0x1c;}' unless defined(&BUS_SPI);
    eval 'sub BUS_RMI () {0x1d;}' unless defined(&BUS_RMI);
    eval 'sub BUS_CEC () {0x1e;}' unless defined(&BUS_CEC);
    eval 'sub BUS_INTEL_ISHTP () {0x1f;}' unless defined(&BUS_INTEL_ISHTP);
    eval 'sub MT_TOOL_FINGER () {0;}' unless defined(&MT_TOOL_FINGER);
    eval 'sub MT_TOOL_PEN () {1;}' unless defined(&MT_TOOL_PEN);
    eval 'sub MT_TOOL_PALM () {2;}' unless defined(&MT_TOOL_PALM);
    eval 'sub MT_TOOL_MAX () {2;}' unless defined(&MT_TOOL_MAX);
    eval 'sub FF_STATUS_STOPPED () {0x;}' unless defined(&FF_STATUS_STOPPED);
    eval 'sub FF_STATUS_PLAYING () {0x1;}' unless defined(&FF_STATUS_PLAYING);
    eval 'sub FF_STATUS_MAX () {0x1;}' unless defined(&FF_STATUS_MAX);
    eval 'sub FF_RUMBLE () {0x50;}' unless defined(&FF_RUMBLE);
    eval 'sub FF_PERIODIC () {0x51;}' unless defined(&FF_PERIODIC);
    eval 'sub FF_CONSTANT () {0x52;}' unless defined(&FF_CONSTANT);
    eval 'sub FF_SPRING () {0x53;}' unless defined(&FF_SPRING);
    eval 'sub FF_FRICTION () {0x54;}' unless defined(&FF_FRICTION);
    eval 'sub FF_DAMPER () {0x55;}' unless defined(&FF_DAMPER);
    eval 'sub FF_INERTIA () {0x56;}' unless defined(&FF_INERTIA);
    eval 'sub FF_RAMP () {0x57;}' unless defined(&FF_RAMP);
    eval 'sub FF_EFFECT_MIN () { &FF_RUMBLE;}' unless defined(&FF_EFFECT_MIN);
    eval 'sub FF_EFFECT_MAX () { &FF_RAMP;}' unless defined(&FF_EFFECT_MAX);
    eval 'sub FF_SQUARE () {0x58;}' unless defined(&FF_SQUARE);
    eval 'sub FF_TRIANGLE () {0x59;}' unless defined(&FF_TRIANGLE);
    eval 'sub FF_SINE () {0x5a;}' unless defined(&FF_SINE);
    eval 'sub FF_SAW_UP () {0x5b;}' unless defined(&FF_SAW_UP);
    eval 'sub FF_SAW_DOWN () {0x5c;}' unless defined(&FF_SAW_DOWN);
    eval 'sub FF_CUSTOM () {0x5d;}' unless defined(&FF_CUSTOM);
    eval 'sub FF_WAVEFORM_MIN () { &FF_SQUARE;}' unless defined(&FF_WAVEFORM_MIN);
    eval 'sub FF_WAVEFORM_MAX () { &FF_CUSTOM;}' unless defined(&FF_WAVEFORM_MAX);
    eval 'sub FF_GAIN () {0x60;}' unless defined(&FF_GAIN);
    eval 'sub FF_AUTOCENTER () {0x61;}' unless defined(&FF_AUTOCENTER);
    eval 'sub FF_MAX_EFFECTS () { &FF_GAIN;}' unless defined(&FF_MAX_EFFECTS);
    eval 'sub FF_MAX () {0x7f;}' unless defined(&FF_MAX);
    eval 'sub FF_CNT () {( &FF_MAX+1);}' unless defined(&FF_CNT);
}
1;
