require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_VIRTIO_CRYPTO_H)) {
    eval 'sub _VIRTIO_CRYPTO_H () {1;}' unless defined(&_VIRTIO_CRYPTO_H);
    require 'linux/types.ph';
    require 'linux/virtio_types.ph';
    require 'linux/virtio_ids.ph';
    require 'linux/virtio_config.ph';
    eval 'sub VIRTIO_CRYPTO_SERVICE_CIPHER () {0;}' unless defined(&VIRTIO_CRYPTO_SERVICE_CIPHER);
    eval 'sub VIRTIO_CRYPTO_SERVICE_HASH () {1;}' unless defined(&VIRTIO_CRYPTO_SERVICE_HASH);
    eval 'sub VIRTIO_CRYPTO_SERVICE_MAC () {2;}' unless defined(&VIRTIO_CRYPTO_SERVICE_MAC);
    eval 'sub VIRTIO_CRYPTO_SERVICE_AEAD () {3;}' unless defined(&VIRTIO_CRYPTO_SERVICE_AEAD);
    eval 'sub VIRTIO_CRYPTO_OPCODE {
        my($service, $op) = @_;
	    eval q(((($service) << 8) | ($op)));
    }' unless defined(&VIRTIO_CRYPTO_OPCODE);
    eval 'sub VIRTIO_CRYPTO_CIPHER_CREATE_SESSION () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_CIPHER, 0x2);}' unless defined(&VIRTIO_CRYPTO_CIPHER_CREATE_SESSION);
    eval 'sub VIRTIO_CRYPTO_CIPHER_DESTROY_SESSION () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_CIPHER, 0x3);}' unless defined(&VIRTIO_CRYPTO_CIPHER_DESTROY_SESSION);
    eval 'sub VIRTIO_CRYPTO_HASH_CREATE_SESSION () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_HASH, 0x2);}' unless defined(&VIRTIO_CRYPTO_HASH_CREATE_SESSION);
    eval 'sub VIRTIO_CRYPTO_HASH_DESTROY_SESSION () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_HASH, 0x3);}' unless defined(&VIRTIO_CRYPTO_HASH_DESTROY_SESSION);
    eval 'sub VIRTIO_CRYPTO_MAC_CREATE_SESSION () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_MAC, 0x2);}' unless defined(&VIRTIO_CRYPTO_MAC_CREATE_SESSION);
    eval 'sub VIRTIO_CRYPTO_MAC_DESTROY_SESSION () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_MAC, 0x3);}' unless defined(&VIRTIO_CRYPTO_MAC_DESTROY_SESSION);
    eval 'sub VIRTIO_CRYPTO_AEAD_CREATE_SESSION () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_AEAD, 0x2);}' unless defined(&VIRTIO_CRYPTO_AEAD_CREATE_SESSION);
    eval 'sub VIRTIO_CRYPTO_AEAD_DESTROY_SESSION () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_AEAD, 0x3);}' unless defined(&VIRTIO_CRYPTO_AEAD_DESTROY_SESSION);
    eval 'sub VIRTIO_CRYPTO_NO_CIPHER () {0;}' unless defined(&VIRTIO_CRYPTO_NO_CIPHER);
    eval 'sub VIRTIO_CRYPTO_CIPHER_ARC4 () {1;}' unless defined(&VIRTIO_CRYPTO_CIPHER_ARC4);
    eval 'sub VIRTIO_CRYPTO_CIPHER_AES_ECB () {2;}' unless defined(&VIRTIO_CRYPTO_CIPHER_AES_ECB);
    eval 'sub VIRTIO_CRYPTO_CIPHER_AES_CBC () {3;}' unless defined(&VIRTIO_CRYPTO_CIPHER_AES_CBC);
    eval 'sub VIRTIO_CRYPTO_CIPHER_AES_CTR () {4;}' unless defined(&VIRTIO_CRYPTO_CIPHER_AES_CTR);
    eval 'sub VIRTIO_CRYPTO_CIPHER_DES_ECB () {5;}' unless defined(&VIRTIO_CRYPTO_CIPHER_DES_ECB);
    eval 'sub VIRTIO_CRYPTO_CIPHER_DES_CBC () {6;}' unless defined(&VIRTIO_CRYPTO_CIPHER_DES_CBC);
    eval 'sub VIRTIO_CRYPTO_CIPHER_3DES_ECB () {7;}' unless defined(&VIRTIO_CRYPTO_CIPHER_3DES_ECB);
    eval 'sub VIRTIO_CRYPTO_CIPHER_3DES_CBC () {8;}' unless defined(&VIRTIO_CRYPTO_CIPHER_3DES_CBC);
    eval 'sub VIRTIO_CRYPTO_CIPHER_3DES_CTR () {9;}' unless defined(&VIRTIO_CRYPTO_CIPHER_3DES_CTR);
    eval 'sub VIRTIO_CRYPTO_CIPHER_KASUMI_F8 () {10;}' unless defined(&VIRTIO_CRYPTO_CIPHER_KASUMI_F8);
    eval 'sub VIRTIO_CRYPTO_CIPHER_SNOW3G_UEA2 () {11;}' unless defined(&VIRTIO_CRYPTO_CIPHER_SNOW3G_UEA2);
    eval 'sub VIRTIO_CRYPTO_CIPHER_AES_F8 () {12;}' unless defined(&VIRTIO_CRYPTO_CIPHER_AES_F8);
    eval 'sub VIRTIO_CRYPTO_CIPHER_AES_XTS () {13;}' unless defined(&VIRTIO_CRYPTO_CIPHER_AES_XTS);
    eval 'sub VIRTIO_CRYPTO_CIPHER_ZUC_EEA3 () {14;}' unless defined(&VIRTIO_CRYPTO_CIPHER_ZUC_EEA3);
    eval 'sub VIRTIO_CRYPTO_OP_ENCRYPT () {1;}' unless defined(&VIRTIO_CRYPTO_OP_ENCRYPT);
    eval 'sub VIRTIO_CRYPTO_OP_DECRYPT () {2;}' unless defined(&VIRTIO_CRYPTO_OP_DECRYPT);
    eval 'sub VIRTIO_CRYPTO_NO_HASH () {0;}' unless defined(&VIRTIO_CRYPTO_NO_HASH);
    eval 'sub VIRTIO_CRYPTO_HASH_MD5 () {1;}' unless defined(&VIRTIO_CRYPTO_HASH_MD5);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA1 () {2;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA1);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA_224 () {3;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA_224);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA_256 () {4;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA_256);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA_384 () {5;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA_384);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA_512 () {6;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA_512);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA3_224 () {7;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA3_224);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA3_256 () {8;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA3_256);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA3_384 () {9;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA3_384);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA3_512 () {10;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA3_512);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA3_SHAKE128 () {11;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA3_SHAKE128);
    eval 'sub VIRTIO_CRYPTO_HASH_SHA3_SHAKE256 () {12;}' unless defined(&VIRTIO_CRYPTO_HASH_SHA3_SHAKE256);
    eval 'sub VIRTIO_CRYPTO_NO_MAC () {0;}' unless defined(&VIRTIO_CRYPTO_NO_MAC);
    eval 'sub VIRTIO_CRYPTO_MAC_HMAC_MD5 () {1;}' unless defined(&VIRTIO_CRYPTO_MAC_HMAC_MD5);
    eval 'sub VIRTIO_CRYPTO_MAC_HMAC_SHA1 () {2;}' unless defined(&VIRTIO_CRYPTO_MAC_HMAC_SHA1);
    eval 'sub VIRTIO_CRYPTO_MAC_HMAC_SHA_224 () {3;}' unless defined(&VIRTIO_CRYPTO_MAC_HMAC_SHA_224);
    eval 'sub VIRTIO_CRYPTO_MAC_HMAC_SHA_256 () {4;}' unless defined(&VIRTIO_CRYPTO_MAC_HMAC_SHA_256);
    eval 'sub VIRTIO_CRYPTO_MAC_HMAC_SHA_384 () {5;}' unless defined(&VIRTIO_CRYPTO_MAC_HMAC_SHA_384);
    eval 'sub VIRTIO_CRYPTO_MAC_HMAC_SHA_512 () {6;}' unless defined(&VIRTIO_CRYPTO_MAC_HMAC_SHA_512);
    eval 'sub VIRTIO_CRYPTO_MAC_CMAC_3DES () {25;}' unless defined(&VIRTIO_CRYPTO_MAC_CMAC_3DES);
    eval 'sub VIRTIO_CRYPTO_MAC_CMAC_AES () {26;}' unless defined(&VIRTIO_CRYPTO_MAC_CMAC_AES);
    eval 'sub VIRTIO_CRYPTO_MAC_KASUMI_F9 () {27;}' unless defined(&VIRTIO_CRYPTO_MAC_KASUMI_F9);
    eval 'sub VIRTIO_CRYPTO_MAC_SNOW3G_UIA2 () {28;}' unless defined(&VIRTIO_CRYPTO_MAC_SNOW3G_UIA2);
    eval 'sub VIRTIO_CRYPTO_MAC_GMAC_AES () {41;}' unless defined(&VIRTIO_CRYPTO_MAC_GMAC_AES);
    eval 'sub VIRTIO_CRYPTO_MAC_GMAC_TWOFISH () {42;}' unless defined(&VIRTIO_CRYPTO_MAC_GMAC_TWOFISH);
    eval 'sub VIRTIO_CRYPTO_MAC_CBCMAC_AES () {49;}' unless defined(&VIRTIO_CRYPTO_MAC_CBCMAC_AES);
    eval 'sub VIRTIO_CRYPTO_MAC_CBCMAC_KASUMI_F9 () {50;}' unless defined(&VIRTIO_CRYPTO_MAC_CBCMAC_KASUMI_F9);
    eval 'sub VIRTIO_CRYPTO_MAC_XCBC_AES () {53;}' unless defined(&VIRTIO_CRYPTO_MAC_XCBC_AES);
    eval 'sub VIRTIO_CRYPTO_NO_AEAD () {0;}' unless defined(&VIRTIO_CRYPTO_NO_AEAD);
    eval 'sub VIRTIO_CRYPTO_AEAD_GCM () {1;}' unless defined(&VIRTIO_CRYPTO_AEAD_GCM);
    eval 'sub VIRTIO_CRYPTO_AEAD_CCM () {2;}' unless defined(&VIRTIO_CRYPTO_AEAD_CCM);
    eval 'sub VIRTIO_CRYPTO_AEAD_CHACHA20_POLY1305 () {3;}' unless defined(&VIRTIO_CRYPTO_AEAD_CHACHA20_POLY1305);
    eval 'sub VIRTIO_CRYPTO_SYM_ALG_CHAIN_ORDER_HASH_THEN_CIPHER () {1;}' unless defined(&VIRTIO_CRYPTO_SYM_ALG_CHAIN_ORDER_HASH_THEN_CIPHER);
    eval 'sub VIRTIO_CRYPTO_SYM_ALG_CHAIN_ORDER_CIPHER_THEN_HASH () {2;}' unless defined(&VIRTIO_CRYPTO_SYM_ALG_CHAIN_ORDER_CIPHER_THEN_HASH);
    eval 'sub VIRTIO_CRYPTO_SYM_HASH_MODE_PLAIN () {1;}' unless defined(&VIRTIO_CRYPTO_SYM_HASH_MODE_PLAIN);
    eval 'sub VIRTIO_CRYPTO_SYM_HASH_MODE_AUTH () {2;}' unless defined(&VIRTIO_CRYPTO_SYM_HASH_MODE_AUTH);
    eval 'sub VIRTIO_CRYPTO_SYM_HASH_MODE_NESTED () {3;}' unless defined(&VIRTIO_CRYPTO_SYM_HASH_MODE_NESTED);
    eval 'sub VIRTIO_CRYPTO_SYM_OP_NONE () {0;}' unless defined(&VIRTIO_CRYPTO_SYM_OP_NONE);
    eval 'sub VIRTIO_CRYPTO_SYM_OP_CIPHER () {1;}' unless defined(&VIRTIO_CRYPTO_SYM_OP_CIPHER);
    eval 'sub VIRTIO_CRYPTO_SYM_OP_ALGORITHM_CHAINING () {2;}' unless defined(&VIRTIO_CRYPTO_SYM_OP_ALGORITHM_CHAINING);
    eval 'sub VIRTIO_CRYPTO_CIPHER_ENCRYPT () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_CIPHER, 0x);}' unless defined(&VIRTIO_CRYPTO_CIPHER_ENCRYPT);
    eval 'sub VIRTIO_CRYPTO_CIPHER_DECRYPT () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_CIPHER, 0x1);}' unless defined(&VIRTIO_CRYPTO_CIPHER_DECRYPT);
    eval 'sub VIRTIO_CRYPTO_HASH () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_HASH, 0x);}' unless defined(&VIRTIO_CRYPTO_HASH);
    eval 'sub VIRTIO_CRYPTO_MAC () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_MAC, 0x);}' unless defined(&VIRTIO_CRYPTO_MAC);
    eval 'sub VIRTIO_CRYPTO_AEAD_ENCRYPT () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_AEAD, 0x);}' unless defined(&VIRTIO_CRYPTO_AEAD_ENCRYPT);
    eval 'sub VIRTIO_CRYPTO_AEAD_DECRYPT () { &VIRTIO_CRYPTO_OPCODE( &VIRTIO_CRYPTO_SERVICE_AEAD, 0x1);}' unless defined(&VIRTIO_CRYPTO_AEAD_DECRYPT);
    eval 'sub VIRTIO_CRYPTO_OK () {0;}' unless defined(&VIRTIO_CRYPTO_OK);
    eval 'sub VIRTIO_CRYPTO_ERR () {1;}' unless defined(&VIRTIO_CRYPTO_ERR);
    eval 'sub VIRTIO_CRYPTO_BADMSG () {2;}' unless defined(&VIRTIO_CRYPTO_BADMSG);
    eval 'sub VIRTIO_CRYPTO_NOTSUPP () {3;}' unless defined(&VIRTIO_CRYPTO_NOTSUPP);
    eval 'sub VIRTIO_CRYPTO_INVSESS () {4;}' unless defined(&VIRTIO_CRYPTO_INVSESS);
    eval 'sub VIRTIO_CRYPTO_S_HW_READY () {(1<< 0);}' unless defined(&VIRTIO_CRYPTO_S_HW_READY);
}
1;
