require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_MATH_H)) {
    eval 'sub _MATH_H () {1;}' unless defined(&_MATH_H);
    eval 'sub __GLIBC_INTERNAL_STARTING_HEADER_IMPLEMENTATION () {1;}' unless defined(&__GLIBC_INTERNAL_STARTING_HEADER_IMPLEMENTATION);
    require 'bits/libc-header-start.ph';
    require 'bits/types.ph';
    require 'bits/math-vector.ph';
    require 'bits/floatn.ph';
    require 'bits/huge_val.ph';
    if((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	require 'bits/huge_val_flt128.ph';
    }
    if(defined(&__USE_ISOC99)) {
	require 'bits/huge_valf.ph';
	require 'bits/huge_vall.ph';
	require 'bits/inf.ph';
	require 'bits/nan.ph';
    }
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT) ? &IEC_60559_BFP_EXT : undef))) {
	if( &__GNUC_PREREQ (3, 3)) {
	    eval 'sub SNANF () {( &__builtin_nansf (""));}' unless defined(&SNANF);
	    eval 'sub SNAN () {( &__builtin_nans (""));}' unless defined(&SNAN);
	    eval 'sub SNANL () {( &__builtin_nansl (""));}' unless defined(&SNANL);
	}
    }
    if((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	eval 'sub SNANF128 () {( &__builtin_nansf128 (""));}' unless defined(&SNANF128);
    }
    require 'bits/flt-eval-method.ph';
    if(defined(&__USE_ISOC99)) {
	if((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 0|| (defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 16) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 1) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 2) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 32) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 33) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 64) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 65) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 128) {
	}
 elsif((defined(&__GLIBC_FLT_EVAL_METHOD) ? &__GLIBC_FLT_EVAL_METHOD : undef) == 129) {
	} else {
	    die("Unknown __GLIBC_FLT_EVAL_METHOD");
	}
    }
    require 'bits/fp-logb.ph';
    if(defined(&__USE_ISOC99)) {
	if((defined(&__FP_LOGB0_IS_MIN) ? &__FP_LOGB0_IS_MIN : undef)) {
	    eval 'sub FP_ILOGB0 () {(-2147483647- 1);}' unless defined(&FP_ILOGB0);
	} else {
	    eval 'sub FP_ILOGB0 () {(-2147483647);}' unless defined(&FP_ILOGB0);
	}
	if((defined(&__FP_LOGBNAN_IS_MIN) ? &__FP_LOGBNAN_IS_MIN : undef)) {
	    eval 'sub FP_ILOGBNAN () {(-2147483647- 1);}' unless defined(&FP_ILOGBNAN);
	} else {
	    eval 'sub FP_ILOGBNAN () {2147483647;}' unless defined(&FP_ILOGBNAN);
	}
    }
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT) ? &IEC_60559_BFP_EXT : undef))) {
	if((defined(&__WORDSIZE) ? &__WORDSIZE : undef) == 32) {
	    eval 'sub __FP_LONG_MAX () {0x7fffffff;}' unless defined(&__FP_LONG_MAX);
	} else {
	    eval 'sub __FP_LONG_MAX () {0x7fffffffffffffff;}' unless defined(&__FP_LONG_MAX);
	}
	if((defined(&__FP_LOGB0_IS_MIN) ? &__FP_LOGB0_IS_MIN : undef)) {
	    eval 'sub FP_LLOGB0 () {(- &__FP_LONG_MAX - 1);}' unless defined(&FP_LLOGB0);
	} else {
	    eval 'sub FP_LLOGB0 () {(- &__FP_LONG_MAX);}' unless defined(&FP_LLOGB0);
	}
	if((defined(&__FP_LOGBNAN_IS_MIN) ? &__FP_LOGBNAN_IS_MIN : undef)) {
	    eval 'sub FP_LLOGBNAN () {(- &__FP_LONG_MAX - 1);}' unless defined(&FP_LLOGBNAN);
	} else {
	    eval 'sub FP_LLOGBNAN () { &__FP_LONG_MAX;}' unless defined(&FP_LLOGBNAN);
	}
    }
    require 'bits/fp-fast.ph';
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT) ? &IEC_60559_BFP_EXT : undef))) {
	eval("sub FP_INT_UPWARD () { FP_INT_UPWARD=0; }") unless defined(&FP_INT_UPWARD);
	eval("sub FP_INT_UPWARD () { 1; }") unless defined(&FP_INT_UPWARD);
	eval("sub FP_INT_DOWNWARD () { FP_INT_DOWNWARD=1; }") unless defined(&FP_INT_DOWNWARD);
	eval("sub FP_INT_DOWNWARD () { 1; }") unless defined(&FP_INT_DOWNWARD);
	eval("sub FP_INT_TOWARDZERO () { FP_INT_TOWARDZERO=2; }") unless defined(&FP_INT_TOWARDZERO);
	eval("sub FP_INT_TOWARDZERO () { 1; }") unless defined(&FP_INT_TOWARDZERO);
	eval("sub FP_INT_TONEARESTFROMZERO () { FP_INT_TONEARESTFROMZERO=3; }") unless defined(&FP_INT_TONEARESTFROMZERO);
	eval("sub FP_INT_TONEARESTFROMZERO () { 1; }") unless defined(&FP_INT_TONEARESTFROMZERO);
	eval("sub FP_INT_TONEAREST () { FP_INT_TONEAREST=4; }") unless defined(&FP_INT_TONEAREST);
	eval("sub FP_INT_TONEAREST () { 1; }") unless defined(&FP_INT_TONEAREST);
    }
    eval 'sub __SIMD_DECL {
        my($function) = @_;
	    eval q( &__CONCAT ( &__DECL_SIMD_, $function));
    }' unless defined(&__SIMD_DECL);
    eval 'sub __MATHCALL_VEC {
        my($function, $suffix, $args) = @_;
	    eval q( &__SIMD_DECL ( &__MATH_PRECNAME ($function, $suffix))  &__MATHCALL ($function, $suffix, $args));
    }' unless defined(&__MATHCALL_VEC);
    eval 'sub __MATHDECL_VEC {
        my($type, $function,$suffix, $args) = @_;
	    eval q( &__SIMD_DECL ( &__MATH_PRECNAME ($function, $suffix))  &__MATHDECL($type, $function,$suffix, $args));
    }' unless defined(&__MATHDECL_VEC);
    eval 'sub __MATHCALL {
        my($function,$suffix, $args) = @_;
	    eval q( &__MATHDECL ( &_Mdouble_,$function,$suffix, $args));
    }' unless defined(&__MATHCALL);
    eval 'sub __MATHDECL {
        my($type, $function,$suffix, $args) = @_;
	    eval q( &__MATHDECL_1($type, $function,$suffix, $args);  &__MATHDECL_1($type,  &__CONCAT( &__,$function),$suffix, $args));
    }' unless defined(&__MATHDECL);
    eval 'sub __MATHCALLX {
        my($function,$suffix, $args, $attrib) = @_;
	    eval q( &__MATHDECLX ( &_Mdouble_,$function,$suffix, $args, $attrib));
    }' unless defined(&__MATHCALLX);
    eval 'sub __MATHDECLX {
        my($type, $function,$suffix, $args, $attrib) = @_;
	    eval q( &__MATHDECL_1($type, $function,$suffix, $args)  &__attribute__ ($attrib);  &__MATHDECL_1($type,  &__CONCAT( &__,$function),$suffix, $args)  &__attribute__ ($attrib));
    }' unless defined(&__MATHDECLX);
    eval 'sub __MATHDECL_1 {
        my($type, $function,$suffix, $args) = @_;
	    eval q( &extern $type  &__MATH_PRECNAME($function,$suffix) $args  &__THROW);
    }' unless defined(&__MATHDECL_1);
    eval 'sub _Mdouble_ () {\'double\';}' unless defined(&_Mdouble_);
    eval 'sub __MATH_PRECNAME {
        my($name,$r) = @_;
	    eval q( &__CONCAT($name,$r));
    }' unless defined(&__MATH_PRECNAME);
    eval 'sub __MATH_DECLARING_DOUBLE () {1;}' unless defined(&__MATH_DECLARING_DOUBLE);
    eval 'sub __MATH_DECLARING_FLOATN () {0;}' unless defined(&__MATH_DECLARING_FLOATN);
    require 'bits/mathcalls-helper-functions.ph';
    require 'bits/mathcalls.ph';
    undef(&_Mdouble_) if defined(&_Mdouble_);
    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
    undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
    undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    if(defined(&__USE_ISOC99)) {
	unless(defined(&_Mfloat_)) {
	    eval 'sub _Mfloat_ () {\'float\';}' unless defined(&_Mfloat_);
	}
	eval 'sub _Mdouble_ () { &_Mfloat_;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {0;}' unless defined(&__MATH_DECLARING_FLOATN);
	require 'bits/mathcalls-helper-functions.ph';
	require 'bits/mathcalls.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
	if(!(defined (&__NO_LONG_DOUBLE_MATH)  && defined (&_LIBC)) || defined (&__LDBL_COMPAT) || defined (&_LIBC_TEST)) {
	    if(defined(&__LDBL_COMPAT)) {
		if(defined(&__USE_ISOC99)) {
		    if(defined(&__REDIRECT_NTH)) {
		    }
		}
		undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
		eval 'sub __MATHDECL_2 {
		    my($type, $function,$suffix, $args, $alias) = @_;
    		    eval q( &extern $type  &__REDIRECT_NTH( &__MATH_PRECNAME($function,$suffix), $args, $alias));
		}' unless defined(&__MATHDECL_2);
		eval 'sub __MATHDECL_1 {
		    my($type, $function,$suffix, $args) = @_;
    		    eval q( &__MATHDECL_2($type, $function,$suffix, $args,  &__CONCAT($function,$suffix)));
		}' unless defined(&__MATHDECL_1);
	    }
	    unless(defined(&_Mlong_double_)) {
		eval 'sub _Mlong_double_ () {\'long double\';}' unless defined(&_Mlong_double_);
	    }
	    eval 'sub _Mdouble_ () {\'_Mlong_double_\';}' unless defined(&_Mdouble_);
	    eval 'sub __MATH_PRECNAME {
	        my($name,$r) = @_;
    		eval q($name &l$r);
	    }' unless defined(&__MATH_PRECNAME);
	    eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	    eval 'sub __MATH_DECLARING_FLOATN () {0;}' unless defined(&__MATH_DECLARING_FLOATN);
	    eval 'sub __MATH_DECLARE_LDOUBLE () {1;}' unless defined(&__MATH_DECLARE_LDOUBLE);
	    require 'bits/mathcalls-helper-functions.ph';
	    require 'bits/mathcalls.ph';
	    undef(&_Mdouble_) if defined(&_Mdouble_);
	    undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	    undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	    undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
	}
    }
    if((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef) || ((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  && !defined (&_LIBC))) {
	unless(defined(&_Mfloat128_)) {
	    eval 'sub _Mfloat128_ () { &_Float128;}' unless defined(&_Mfloat128_);
	}
	eval 'sub _Mdouble_ () { &_Mfloat128_;}' unless defined(&_Mdouble_);
	eval 'sub __MATH_PRECNAME {
	    my($name,$r) = @_;
    	    eval q($name &f128$r);
	}' unless defined(&__MATH_PRECNAME);
	eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {1;}' unless defined(&__MATH_DECLARING_FLOATN);
	if((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef)) {
	    require 'bits/mathcalls-helper-functions.ph';
	}
	if( &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	    require 'bits/mathcalls.ph';
	}
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_PRECNAME) if defined(&__MATH_PRECNAME);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
    }
    undef(&__MATHDECL_1) if defined(&__MATHDECL_1);
    undef(&__MATHDECL) if defined(&__MATHDECL);
    undef(&__MATHCALL) if defined(&__MATHCALL);
    if(defined (&__USE_MISC) || defined (&__USE_XOPEN)) {
    }
    if(defined(&__NO_LONG_DOUBLE_MATH)) {
	eval 'sub __MATH_TG {
	    my($TG_ARG, $FUNC, $ARGS) = @_;
    	    eval q(($sizeof{$TG_ARG} == $sizeof{\'float\'} ? $FUNC   &f $ARGS : $FUNC $ARGS));
	}' unless defined(&__MATH_TG);
    }
 elsif((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef)) {
	if((defined(&__HAVE_GENERIC_SELECTION) ? &__HAVE_GENERIC_SELECTION : undef)) {
	    eval 'sub __MATH_TG {
	        my($TG_ARG, $FUNC, $ARGS) = @_;
    		eval q( &_Generic (($TG_ARG), \'float\': $FUNC   &f $ARGS,  &default: $FUNC $ARGS, \'long double\': $FUNC   &l $ARGS,  &_Float128: $FUNC   &f128 $ARGS));
	    }' unless defined(&__MATH_TG);
	} else {
	    eval 'sub __MATH_TG {
	        my($TG_ARG, $FUNC, $ARGS) = @_;
    		eval q( &__builtin_choose_expr ( &__builtin_types_compatible_p ( &__typeof ($TG_ARG), \'float\'), $FUNC   &f $ARGS,  &__builtin_choose_expr ( &__builtin_types_compatible_p ( &__typeof ($TG_ARG), \'double\'), $FUNC $ARGS,  &__builtin_choose_expr ( &__builtin_types_compatible_p ( &__typeof ($TG_ARG), \'long double\'), $FUNC   &l $ARGS, $FUNC   &f128 $ARGS))));
	    }' unless defined(&__MATH_TG);
	}
    } else {
	eval 'sub __MATH_TG {
	    my($TG_ARG, $FUNC, $ARGS) = @_;
    	    eval q(($sizeof{$TG_ARG} == $sizeof{\'float\'} ? $FUNC   &f $ARGS : $sizeof{$TG_ARG} == $sizeof{\'double\'} ? $FUNC $ARGS : $FUNC   &l $ARGS));
	}' unless defined(&__MATH_TG);
    }
    if(defined(&__USE_ISOC99)) {
	eval("sub FP_NAN () { FP_NAN=0; }") unless defined(&FP_NAN);
	eval("sub FP_NAN () { 1; }") unless defined(&FP_NAN);
	eval("sub FP_INFINITE () { FP_INFINITE=1; }") unless defined(&FP_INFINITE);
	eval("sub FP_INFINITE () { 1; }") unless defined(&FP_INFINITE);
	eval("sub FP_ZERO () { FP_ZERO=2; }") unless defined(&FP_ZERO);
	eval("sub FP_ZERO () { 1; }") unless defined(&FP_ZERO);
	eval("sub FP_SUBNORMAL () { FP_SUBNORMAL=3; }") unless defined(&FP_SUBNORMAL);
	eval("sub FP_SUBNORMAL () { 1; }") unless defined(&FP_SUBNORMAL);
	eval("sub FP_NORMAL () { FP_NORMAL=4; }") unless defined(&FP_NORMAL);
	eval("sub FP_NORMAL () { 1; }") unless defined(&FP_NORMAL);
	if( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)  && (!defined (&__OPTIMIZE_SIZE__) || defined (&__cplusplus))) {
	    eval 'sub fpclassify {
	        my($x) = @_;
    		eval q( &__builtin_fpclassify ( &FP_NAN,  &FP_INFINITE,  &FP_NORMAL,  &FP_SUBNORMAL,  &FP_ZERO, $x));
	    }' unless defined(&fpclassify);
	} else {
	    eval 'sub fpclassify {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__fpclassify, ($x)));
	    }' unless defined(&fpclassify);
	}
	if( &__GNUC_PREREQ (6,0)) {
	    eval 'sub signbit {
	        my($x) = @_;
    		eval q( &__builtin_signbit ($x));
	    }' unless defined(&signbit);
	}
 elsif(defined (&__cplusplus)) {
	    eval 'sub signbit {
	        my($x) = @_;
    		eval q( &__builtin_signbitl ($x));
	    }' unless defined(&signbit);
	}
 elsif( &__GNUC_PREREQ (4,0)) {
	    eval 'sub signbit {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__builtin_signbit, ($x)));
	    }' unless defined(&signbit);
	} else {
	    eval 'sub signbit {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__signbit, ($x)));
	    }' unless defined(&signbit);
	}
	if( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)) {
	    eval 'sub isfinite {
	        my($x) = @_;
    		eval q( &__builtin_isfinite ($x));
	    }' unless defined(&isfinite);
	} else {
	    eval 'sub isfinite {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__finite, ($x)));
	    }' unless defined(&isfinite);
	}
	if( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)) {
	    eval 'sub isnormal {
	        my($x) = @_;
    		eval q( &__builtin_isnormal ($x));
	    }' unless defined(&isnormal);
	} else {
	    eval 'sub isnormal {
	        my($x) = @_;
    		eval q(( &fpclassify ($x) ==  &FP_NORMAL));
	    }' unless defined(&isnormal);
	}
	if( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)) {
	    eval 'sub isnan {
	        my($x) = @_;
    		eval q( &__builtin_isnan ($x));
	    }' unless defined(&isnan);
	} else {
	    eval 'sub isnan {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__isnan, ($x)));
	    }' unless defined(&isnan);
	}
	if((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef)  && ! &__GNUC_PREREQ (7,0)  && !defined (&__SUPPORT_SNAN__)  && !defined (&__cplusplus)) {
	    eval 'sub isinf {
	        my($x) = @_;
    		eval q(( &__builtin_types_compatible_p ( &__typeof ($x),  &_Float128) ?  &__isinff128 ($x) :  &__builtin_isinf_sign ($x)));
	    }' unless defined(&isinf);
	}
 elsif( &__GNUC_PREREQ (4,4)  && !defined (&__SUPPORT_SNAN__)) {
	    eval 'sub isinf {
	        my($x) = @_;
    		eval q( &__builtin_isinf_sign ($x));
	    }' unless defined(&isinf);
	} else {
	    eval 'sub isinf {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__isinf, ($x)));
	    }' unless defined(&isinf);
	}
	eval 'sub MATH_ERRNO () {1;}' unless defined(&MATH_ERRNO);
	eval 'sub MATH_ERREXCEPT () {2;}' unless defined(&MATH_ERREXCEPT);
	unless(defined(&__FAST_MATH__)) {
	    eval 'sub math_errhandling () {( &MATH_ERRNO |  &MATH_ERREXCEPT);}' unless defined(&math_errhandling);
	}
    }
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT) ? &IEC_60559_BFP_EXT : undef))) {
	require 'bits/iscanonical.ph';
	unless(defined(&__cplusplus)) {
	    eval 'sub issignaling {
	        my($x) = @_;
    		eval q( &__MATH_TG (($x),  &__issignaling, ($x)));
	    }' unless defined(&issignaling);
	} else {
	    if(defined(&__NO_LONG_DOUBLE_MATH)) {
	    } else {
	    }
	    if((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef)) {
	    }
	}
	eval 'sub issubnormal {
	    my($x) = @_;
    	    eval q(( &fpclassify ($x) ==  &FP_SUBNORMAL));
	}' unless defined(&issubnormal);
	unless(defined(&__cplusplus)) {
	    if(defined(&__SUPPORT_SNAN__)) {
		eval 'sub iszero {
		    my($x) = @_;
    		    eval q(( &fpclassify ($x) ==  &FP_ZERO));
		}' unless defined(&iszero);
	    } else {
		eval 'sub iszero {
		    my($x) = @_;
    		    eval q(((( &__typeof ($x)) ($x)) == 0));
		}' unless defined(&iszero);
	    }
	} else {
	    if(defined(&__SUPPORT_SNAN__)) {
		if(defined(&__NO_LONG_DOUBLE_MATH)) {
		} else {
		}
		if((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef)) {
		}
	    } else {
	    }
	}
    }
    if(defined(&__USE_MISC)) {
	eval("sub _IEEE_ () { -1; }") unless defined(&_IEEE_);
	eval("sub _SVID_ () { 0; }") unless defined(&_SVID_);
	eval("sub _XOPEN_ () { 1; }") unless defined(&_XOPEN_);
	eval("sub _POSIX_ () { 2; }") unless defined(&_POSIX_);
	eval("sub _ISOC_ () { 3; }") unless defined(&_ISOC_);
    }
    if(defined(&__USE_MISC)) {
	if(defined(&__cplusplus)) {
	} else {
	}
	if(defined(&__cplusplus)) {
	} else {
	}
	eval 'sub X_TLOSS () {1.41484755040568800000e+16;}' unless defined(&X_TLOSS);
	eval 'sub DOMAIN () {1;}' unless defined(&DOMAIN);
	eval 'sub SING () {2;}' unless defined(&SING);
	eval 'sub OVERFLOW () {3;}' unless defined(&OVERFLOW);
	eval 'sub UNDERFLOW () {4;}' unless defined(&UNDERFLOW);
	eval 'sub TLOSS () {5;}' unless defined(&TLOSS);
	eval 'sub PLOSS () {6;}' unless defined(&PLOSS);
	eval 'sub HUGE () {3.40282347e+38;}' unless defined(&HUGE);
    } else {
	if(defined(&__USE_XOPEN)) {
	    eval 'sub MAXFLOAT () {3.40282347e+38;}' unless defined(&MAXFLOAT);
	}
    }
    if(defined (&__USE_MISC) || defined (&__USE_XOPEN)) {
	eval 'sub M_E () {2.7182818284590452354;}' unless defined(&M_E);
	eval 'sub M_LOG2E () {1.4426950408889634074;}' unless defined(&M_LOG2E);
	eval 'sub M_LOG10E () {0.43429448190325182765;}' unless defined(&M_LOG10E);
	eval 'sub M_LN2 () {0.69314718055994530942;}' unless defined(&M_LN2);
	eval 'sub M_LN10 () {2.30258509299404568402;}' unless defined(&M_LN10);
	eval 'sub M_PI () {3.14159265358979323846;}' unless defined(&M_PI);
	eval 'sub M_PI_2 () {1.57079632679489661923;}' unless defined(&M_PI_2);
	eval 'sub M_PI_4 () {0.78539816339744830962;}' unless defined(&M_PI_4);
	eval 'sub M_1_PI () {0.31830988618379067154;}' unless defined(&M_1_PI);
	eval 'sub M_2_PI () {0.63661977236758134308;}' unless defined(&M_2_PI);
	eval 'sub M_2_SQRTPI () {1.12837916709551257390;}' unless defined(&M_2_SQRTPI);
	eval 'sub M_SQRT2 () {1.41421356237309504880;}' unless defined(&M_SQRT2);
	eval 'sub M_SQRT1_2 () {0.70710678118654752440;}' unless defined(&M_SQRT1_2);
    }
    if(defined(&__USE_GNU)) {
	eval 'sub M_El () {2.718281828459045235360287471352662498;}' unless defined(&M_El);
	eval 'sub M_LOG2El () {1.442695040888963407359924681001892137;}' unless defined(&M_LOG2El);
	eval 'sub M_LOG10El () {0.434294481903251827651128918916605082;}' unless defined(&M_LOG10El);
	eval 'sub M_LN2l () {0.693147180559945309417232121458176568;}' unless defined(&M_LN2l);
	eval 'sub M_LN10l () {2.302585092994045684017991454684364208;}' unless defined(&M_LN10l);
	eval 'sub M_PIl () {3.141592653589793238462643383279502884;}' unless defined(&M_PIl);
	eval 'sub M_PI_2l () {1.570796326794896619231321691639751442;}' unless defined(&M_PI_2l);
	eval 'sub M_PI_4l () {0.785398163397448309615660845819875721;}' unless defined(&M_PI_4l);
	eval 'sub M_1_PIl () {0.318309886183790671537767526745028724;}' unless defined(&M_1_PIl);
	eval 'sub M_2_PIl () {0.636619772367581343075535053490057448;}' unless defined(&M_2_PIl);
	eval 'sub M_2_SQRTPIl () {1.128379167095512573896158903121545172;}' unless defined(&M_2_SQRTPIl);
	eval 'sub M_SQRT2l () {1.414213562373095048801688724209698079;}' unless defined(&M_SQRT2l);
	eval 'sub M_SQRT1_2l () {0.707106781186547524400844362104849039;}' unless defined(&M_SQRT1_2l);
    }
    if((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  && defined (&__USE_GNU)) {
	eval 'sub M_Ef128 () { &__f128 (2.718281828459045235360287471352662498);}' unless defined(&M_Ef128);
	eval 'sub M_LOG2Ef128 () { &__f128 (1.442695040888963407359924681001892137);}' unless defined(&M_LOG2Ef128);
	eval 'sub M_LOG10Ef128 () { &__f128 (0.434294481903251827651128918916605082);}' unless defined(&M_LOG10Ef128);
	eval 'sub M_LN2f128 () { &__f128 (0.693147180559945309417232121458176568);}' unless defined(&M_LN2f128);
	eval 'sub M_LN10f128 () { &__f128 (2.302585092994045684017991454684364208);}' unless defined(&M_LN10f128);
	eval 'sub M_PIf128 () { &__f128 (3.141592653589793238462643383279502884);}' unless defined(&M_PIf128);
	eval 'sub M_PI_2f128 () { &__f128 (1.570796326794896619231321691639751442);}' unless defined(&M_PI_2f128);
	eval 'sub M_PI_4f128 () { &__f128 (0.785398163397448309615660845819875721);}' unless defined(&M_PI_4f128);
	eval 'sub M_1_PIf128 () { &__f128 (0.318309886183790671537767526745028724);}' unless defined(&M_1_PIf128);
	eval 'sub M_2_PIf128 () { &__f128 (0.636619772367581343075535053490057448);}' unless defined(&M_2_PIf128);
	eval 'sub M_2_SQRTPIf128 () { &__f128 (1.128379167095512573896158903121545172);}' unless defined(&M_2_SQRTPIf128);
	eval 'sub M_SQRT2f128 () { &__f128 (1.414213562373095048801688724209698079);}' unless defined(&M_SQRT2f128);
	eval 'sub M_SQRT1_2f128 () { &__f128 (0.707106781186547524400844362104849039);}' unless defined(&M_SQRT1_2f128);
    }
    if(defined (&__STRICT_ANSI__)  && !defined (&__NO_MATH_INLINES)) {
	eval 'sub __NO_MATH_INLINES () {1;}' unless defined(&__NO_MATH_INLINES);
    }
    if(defined (&__USE_ISOC99)  &&  &__GNUC_PREREQ(2,97)) {
	eval 'sub isgreater {
	    my($x, $y) = @_;
    	    eval q( &__builtin_isgreater($x, $y));
	}' unless defined(&isgreater);
	eval 'sub isgreaterequal {
	    my($x, $y) = @_;
    	    eval q( &__builtin_isgreaterequal($x, $y));
	}' unless defined(&isgreaterequal);
	eval 'sub isless {
	    my($x, $y) = @_;
    	    eval q( &__builtin_isless($x, $y));
	}' unless defined(&isless);
	eval 'sub islessequal {
	    my($x, $y) = @_;
    	    eval q( &__builtin_islessequal($x, $y));
	}' unless defined(&islessequal);
	eval 'sub islessgreater {
	    my($x, $y) = @_;
    	    eval q( &__builtin_islessgreater($x, $y));
	}' unless defined(&islessgreater);
	eval 'sub isunordered {
	    my($u, $v) = @_;
    	    eval q( &__builtin_isunordered($u, $v));
	}' unless defined(&isunordered);
    }
    if(defined(&__USE_EXTERN_INLINES)) {
	require 'bits/mathinline.ph';
    }
    if(defined (&__FINITE_MATH_ONLY__)  && (defined(&__FINITE_MATH_ONLY__) ? &__FINITE_MATH_ONLY__ : undef) > 0) {
	eval 'sub _Mdouble_ () {\'double\';}' unless defined(&_Mdouble_);
	eval 'sub __MATH_DECLARING_DOUBLE () {1;}' unless defined(&__MATH_DECLARING_DOUBLE);
	eval 'sub __MATH_DECLARING_LDOUBLE () {0;}' unless defined(&__MATH_DECLARING_LDOUBLE);
	eval 'sub __MATH_DECLARING_FLOATN () {0;}' unless defined(&__MATH_DECLARING_FLOATN);
	eval 'sub _MSUF_ () {1;}' unless defined(&_MSUF_);
	require 'bits/math-finite.ph';
	undef(&_Mdouble_) if defined(&_Mdouble_);
	undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	undef(&__MATH_DECLARING_LDOUBLE) if defined(&__MATH_DECLARING_LDOUBLE);
	undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
	undef(&_MSUF_) if defined(&_MSUF_);
	if(defined(&__USE_ISOC99)) {
	    eval 'sub _Mdouble_ () {\'float\';}' unless defined(&_Mdouble_);
	    eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	    eval 'sub __MATH_DECLARING_LDOUBLE () {0;}' unless defined(&__MATH_DECLARING_LDOUBLE);
	    eval 'sub __MATH_DECLARING_FLOATN () {0;}' unless defined(&__MATH_DECLARING_FLOATN);
	    eval 'sub _MSUF_ () { &f;}' unless defined(&_MSUF_);
	    require 'bits/math-finite.ph';
	    undef(&_Mdouble_) if defined(&_Mdouble_);
	    undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	    undef(&__MATH_DECLARING_LDOUBLE) if defined(&__MATH_DECLARING_LDOUBLE);
	    undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
	    undef(&_MSUF_) if defined(&_MSUF_);
	    if(defined(&__MATH_DECLARE_LDOUBLE)) {
		eval 'sub _Mdouble_ () {\'long double\';}' unless defined(&_Mdouble_);
		eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
		eval 'sub __MATH_DECLARING_LDOUBLE () {1;}' unless defined(&__MATH_DECLARING_LDOUBLE);
		eval 'sub __MATH_DECLARING_FLOATN () {0;}' unless defined(&__MATH_DECLARING_FLOATN);
		eval 'sub _MSUF_ () { &l;}' unless defined(&_MSUF_);
		require 'bits/math-finite.ph';
		undef(&_Mdouble_) if defined(&_Mdouble_);
		undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
		undef(&__MATH_DECLARING_LDOUBLE) if defined(&__MATH_DECLARING_LDOUBLE);
		undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
		undef(&_MSUF_) if defined(&_MSUF_);
	    }
	}
	if(((defined(&__HAVE_DISTINCT_FLOAT128) ? &__HAVE_DISTINCT_FLOAT128 : undef) || ((defined(&__HAVE_FLOAT128) ? &__HAVE_FLOAT128 : undef)  && !defined (&_LIBC)))  &&  &__GLIBC_USE ((defined(&IEC_60559_TYPES_EXT) ? &IEC_60559_TYPES_EXT : undef))) {
	    eval 'sub _Mdouble_ () { &_Float128;}' unless defined(&_Mdouble_);
	    eval 'sub __MATH_DECLARING_DOUBLE () {0;}' unless defined(&__MATH_DECLARING_DOUBLE);
	    eval 'sub __MATH_DECLARING_LDOUBLE () {0;}' unless defined(&__MATH_DECLARING_LDOUBLE);
	    eval 'sub __MATH_DECLARING_FLOATN () {1;}' unless defined(&__MATH_DECLARING_FLOATN);
	    eval 'sub _MSUF_ () { &f128;}' unless defined(&_MSUF_);
	    require 'bits/math-finite.ph';
	    undef(&_Mdouble_) if defined(&_Mdouble_);
	    undef(&__MATH_DECLARING_DOUBLE) if defined(&__MATH_DECLARING_DOUBLE);
	    undef(&__MATH_DECLARING_LDOUBLE) if defined(&__MATH_DECLARING_LDOUBLE);
	    undef(&__MATH_DECLARING_FLOATN) if defined(&__MATH_DECLARING_FLOATN);
	    undef(&_MSUF_) if defined(&_MSUF_);
	}
    }
    if(defined(&__USE_ISOC99)) {
	unless(defined(&isgreater)) {
	    eval 'sub isgreater {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__($x)  &__x = ($x);  &__typeof__($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  &&  &__x >  &__y; })));
	    }' unless defined(&isgreater);
	}
	unless(defined(&isgreaterequal)) {
	    eval 'sub isgreaterequal {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__($x)  &__x = ($x);  &__typeof__($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  &&  &__x >=  &__y; })));
	    }' unless defined(&isgreaterequal);
	}
	unless(defined(&isless)) {
	    eval 'sub isless {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__($x)  &__x = ($x);  &__typeof__($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  &&  &__x <  &__y; })));
	    }' unless defined(&isless);
	}
	unless(defined(&islessequal)) {
	    eval 'sub islessequal {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__($x)  &__x = ($x);  &__typeof__($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  &&  &__x <=  &__y; })));
	    }' unless defined(&islessequal);
	}
	unless(defined(&islessgreater)) {
	    eval 'sub islessgreater {
	        my($x, $y) = @_;
    		eval q(( &__extension__ ({  &__typeof__($x)  &__x = ($x);  &__typeof__($y)  &__y = ($y); ! &isunordered ( &__x,  &__y)  && ( &__x <  &__y ||  &__y <  &__x); })));
	    }' unless defined(&islessgreater);
	}
	unless(defined(&isunordered)) {
	    eval 'sub isunordered {
	        my($u, $v) = @_;
    		eval q(( &__extension__ ({  &__typeof__($u)  &__u = ($u);  &__typeof__($v)  &__v = ($v);  &fpclassify ( &__u) ==  &FP_NAN ||  &fpclassify ( &__v) ==  &FP_NAN; })));
	    }' unless defined(&isunordered);
	}
    }
    if( &__GLIBC_USE ((defined(&IEC_60559_BFP_EXT) ? &IEC_60559_BFP_EXT : undef))) {
	if((defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) == 2|| (defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) > 64) {
	    eval 'sub __MATH_EVAL_FMT2 {
	        my($x, $y) = @_;
    		eval q((($x) + ($y) + 0.0));
	    }' unless defined(&__MATH_EVAL_FMT2);
	}
 elsif((defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) == 1|| (defined(&__FLT_EVAL_METHOD__) ? &__FLT_EVAL_METHOD__ : undef) > 32) {
	    eval 'sub __MATH_EVAL_FMT2 {
	        my($x, $y) = @_;
    		eval q((($x) + ($y) + 0.0));
	    }' unless defined(&__MATH_EVAL_FMT2);
	} else {
	    eval 'sub __MATH_EVAL_FMT2 {
	        my($x, $y) = @_;
    		eval q((($x) + ($y)));
	    }' unless defined(&__MATH_EVAL_FMT2);
	}
	eval 'sub iseqsig {
	    my($x, $y) = @_;
    	    eval q( &__MATH_TG ( &__MATH_EVAL_FMT2 ($x, $y),  &__iseqsig, (($x), ($y))));
	}' unless defined(&iseqsig);
    }
}
1;
